; PROGRAM GENERATES TIME BASE OF 1 SECOND WITH INTERRUPTS
; OF TIMER 0. FLASHES LED 7 EACH SECOND.
; USES TMR0 WITH 8 BITS AND PRESCALLER (256) TO GENERATE
; 5.46 MILISECONDS POR EACH INTERRUPT CYCLE.
; 183 CYCLES IS APROXIMATELY 1 SECOND.


	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

CONT1	EQU	H'60'			;CONTADOR DE CICLOS DE 65.5 MILISEGUNDOS. 

;aqu inicia el programa
org 	0X800
		goto 	begin			;SALTA AL PROGRAMA PRINCIPAL
				
		org 	0x808			;subrutina de interrupcin en la direccin 0x808				
		clrf	TMR0L			;inicializa TMR0
		bcf		INTCON,TMR0IF	;apaga bandera de overflow del TMR0
		incf	CONT1,f			;incrementa contador de 65.5 ms.
		movlw	D'183'
		subwf	CONT1,w			;prueba si la cuenta es igual a 183
		btfss	STATUS,Z		;bandera Z encendida?
		retfie					;cuenta diferente a 183, regresa
		BTFSS	LED7			;LED ENCENDIDO?
		GOTO	ENC		
		BCF		LED7			;APAGA LED
		CLRF	CONT1
		retfie	
ENC		BSF		LED7			;ENCIENDE LED
		CLRF	CONT1		
		retfie

;PROGRAMA PRINCIPAL
begin	PUERTOS					;inicializa puertos.
		clrf	CONT1			;programa principal			
		movlw	B'11000111'		;HABILITA TEMPORIZADOR A 8 BITS Y CLOCK INTERNO					
		movwf	T0CON			;PREESCALADOR DIVIDE ENTRE 256
		movlw	D'00'
		movwf	TMR0L			;INICIALIZA TEMPORIZADOR=0	
		bsf		INTCON,GIE		;habilita interrupciones global
		bsf		INTCON,TMR0IE	;habilita interrupcin del temporizador.
SIGUE	GOTO	SIGUE
		end



