/******************************************************************************
Electronic lock with saving of password in EEPROM
-Shows in LCD the last password of 4 decimal digits saved in EEPROM during 2 seconds
-Shows a promt '>'
-Receives from user 4 decimal digits (0..9), with ECHO, (type'F' at end).
-If entered number is equal to password, activates relay for 2 seconds.
-If number is not equal, shows the text "error" in LCD
-Permits the user modify password by setting SW1=1 (OFF), and resseting board
-if SW1=1, shows the text "code". User must type new password of 4 digits 
('F' at the end) and saves data to EEPROM, showing the message "code OK"
-The first time that the system runs, user must set SW1=1, so that the password
is entered for first time and saved in EEPROM
******************************************************************************/

#include <p18cxxx.h>
#include <delays.h>
#include <stdio.h>		//librera sprintf()
#include <stdlib.h>		//libreras atoi(),atof()
#include "18F2550BOLT.h"

extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800
 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code
int clave;
char code[]="code";
char codeok[]="code ok";
int binario,i;
int dir_eeprom=60;
char no[]="error";
void main (void)
{
	init_bolt();
	InitLCD();
		if(SW1==1)
		{
			PrintString(code);
			GotoXY(1,0);
			SetBot();
				for(i=0;i<4;i++)
				{
					writeeeprom(dir_eeprom,bot[i]);
					dir_eeprom++;		
				}
			clave=atoi(bot);
			ClearScreen();
			PrintString(codeok);
			delay_ms(1000);
		}
		else 
		{
		for(i=0;i<4;i++)
				{
					bot[i]=readeeprom(dir_eeprom);
					dir_eeprom++;
					PutLCD(bot[i]);	
					bot[4]=0;	
				}
		clave=atoi(bot);
		delay_ms(1000);
		}
	while(1)
	{
		ClearScreen();
		PutLCD('>');
		SetBot();
		binario=atoi(bot);
			if(binario==clave)
			{
				RELE=1;
				delay_ms(1000);
				RELE=0;
				delay_ms(1000);
			}
			else
			{
				ClearScreen();
				delay_ms(1000);
				PrintString(no);
				delay_ms(1000);
			}
	}
}


 
