/*Program Bolt-SMS for modem Wavecom M1306B. Final version. 
Mplab-ide version 8.63, c18 version 3.40. Bolt board is connected  to  modem wavecom m1306b through serial port. 
Password is "WAV  ". There are 4 commands that may be sent from mobile: "WAV R1" to activate relay, "WAV R0" to deactivate relay. 
Bolt system sends a confirmation message to user: "relevador activo" (relay ON)   "relevador inactivo" (relay OFF). 
Command "WAV ST", sends the system status for example: "user ok relevador activo puerta abierta" (relay ON, door OPEN). 
Command "WAV TP", sends to mobile the reading of the digital temperature sensor DS18B20 in degrees centigrade.
If password is incorrect, Bolt system analyzes message but do not take any action. After reset to Bolt, program shows in LCD 
the phone number of the last mobile that sent a valid SMS to the system. Password may be changed in array "pass[5]". 
User must compile program again and load in Bolt system. Program also detects a digital alarm through bit RA4. 
To actvate this function, user must connect a interface circuit. If system detects an active alarm, will send automatically 
a SMS to user mobile with the text "puerta abierta" (door OPEN) or "puerta cerrada (door CLOSED). Alarm may be emulated 
by moving switch SW1 to ON position for door closed and OFF position for door open*/
/******************************************TESTINg OK************************************************/

#include <p18cxxx.h>
#include <delays.h>
#include <usart.h>
#include <stdio.h>		//librera sprintf()
#include <stdlib.h>		//libreras atoi(),atof()
#include <string.h>
#include "18F2550BOLT.h"
#include "ONEWIRE-BOLT.h"

extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 
#pragma code

void atwrite(void);
void clearbuffer(void);
void cleararray(void);
void lee_telefono(void);
void read_phoneLCD(void);
char timed_getc(void);
void at(void);
void CSQ(void);				
void CREG(void);
void CMGF(void);
void CMGD(void);
void CMGL(void);
void CMGS1(int h);
void pin(void);
void activa_serial(void);
void stringwave(int h);						//funcin para recibir respuesta del mdem. Se usa como argumento el ltimo caracter
void starwave(void);					//funcin para esperar la confirmacin del mensaje enviado
char getcECO(void);
char getcNOECO(void);

float GRADOS;
int entero,decimal;					//float GRADOS;
int LEN;
signed int z;								//variable almacena la longitud del comando
int LENWAVE;
char a,r,x,y;
char array[5];
char TEMPE[]="TEMPE=";
char PASS[5]="WAV ";							//PASSWORD: 4 CARACTERES: W,A,V, <ESPACIO>
char arraywave[70];						//arreglo para guardar la cadena de caracteres de la respuesta del mdem.
const char USER[]="USER: ";
const char NOHAY[]="NO HAY";
const char USUARIO[]="USUARIO";
const char MODEM[]="MODEM";
const char GSMOK[]="GSM OK";
const char GSMOFF[]="GSM OFF";
const char ALARMA[]="ALARMA";
const char ACTIVA[]="ACTIVA";
const char SENT[]="SENT>>";
const char WAIT[]="WAIT>>>";
const char RECIBIDO[]="RECIBIDO";
const char TEL[]="TEL:  ";
const char PAS[]="PASS:";
const char OK[]="++OK++";
const char ENVIANDO[]="ENVIANDO";
const char GUARDA[]="GUARDA";
const char BUFFER[]="BUFFER:";
const char SEN[]="SENT>>";
const char NOK[]="++NOK++";
const char AT[]="AT";


	
void main()
{
init_bolt();
InitLCD();
activa_serial();
cleararray();					//borra el arreglo arraywave[]	
	RELE=0;
	z=readeeprom(10);				//lee flag de usuario autorizado***
		if(z==106)
		{
		lee_telefono();				//lee el telfono del usuario autorizado, lo almacena en el arreglo arraywave[]
		ClearScreen();
		PrintString(USER);
		PutLCD(readeeprom(8));
		PutLCD(readeeprom(9));		//muestra la clave LADA
		GotoXY(1,0);
		PrintString(arraywave);		//muestra en LCD el telfono del cual se envi el ltimo comando.
		delay_ms(2000);
		}
		else
		{
		ClearScreen();
		PrintString(NOHAY);
		GotoXY(1,0);
		PrintString(USUARIO);	
		delay_ms(1000);
		}
loop:
	activa_serial();
	at();							//enva el comando AT, confirma OK
	CSQ();								//ENVA COMANDO AT+CSQ	
	stringwave(',');					//recibe string hasta que encuentres la coma
	delay_ms(200);
	ClearScreen();
		for(a=4;a<LENWAVE;a++)
		{
		PutLCD(arraywave[a]);				//escribe en LCD respuesta del mdem
		}
	delay_ms(500);
	activa_serial();					
	CREG();						//enva comando AT+CREG?
	stringwave('K');					//recibe respuesta, llena el arreglo hasta recibir una "K"
	delay_ms(200);
	ClearScreen();
		for(a=5;a<LENWAVE-3;a++)
		{
		PutLCD(arraywave[a]);				//escribe en LCD respuesta del mdem
		}
	delay_ms(2000);
		if(arraywave[12]=='1')
		{
		ClearScreen();
		PrintString(MODEM);
		GotoXY(1,0);
		PrintString(GSMOK);
		delay_ms(2000);
		}
		else
		{
		ClearScreen();
		PrintString(MODEM);
		GotoXY(1,0);
		PrintString(GSMOFF);
		delay_ms(2000);
		goto loop;						//MDEM NO CONECTADO A LA RED GSM, REPITE INICIALIZACIN.
		}
	delay_ms(1000);
	activa_serial();
	CMGF();								//enva comando AT+CMGF? VERIFICA MDEM EN MODO TEXTO
	stringwave('K');					//recibe respuesta, llena el arreglo hasta recibir una "K"
	delay_ms(200);
	ClearScreen();
		for(a=3;a<LENWAVE-2;a++)
		{
		PutLCD(arraywave[a]);				//escribe en LCD respuesta del mdem
		}
	delay_ms(2000);
	clearbuffer();							//borra los mensajes de entrada que estn en el buffer de mensajes SMS del mdem.
	clearbuffer();							//asegura que no exista ningn mensaje en el buffer.
	
	
//***************INICIO MALLA PRINCIPAL DEL PROGRAMA. ESPERA MENSAJE SMS, LEE SEAL DE ALARMA****************************************
mallachica:
	ClearScreen();
		if(SW1==1)
		{
		z=readeeprom(11);							//lee bandera de puerta abierta. z=0, puerta cerrada; z=106, puerta abierta.
			if(z==0)								//verifica que anteriormente la puerta haya estado cerrada.
			{
			writeeeprom(11,106);						//guarda un 106 en la localidad 11, que es la bandera de que puerta se detect abierta***		
			PrintString(ALARMA);
			GotoXY(1,0);
			PrintString(ACTIVA);					//DETECCION DE ALARMA ACTIVA
			delay_ms(2000);
			r=3;
			activa_serial();
			CMGS1(r);								//ENVA EL MENSAJE AL TELFONO AUTORIZADO. EL ARGUMENTO (r) DE LA FUNCIN
			cleararray();							//LIMPIA ARREGLO BUFFER arraywave[],DE RECEPCIN DE CARACTERES DEL MDEM
			starwave();								//ESPERA LA RESPUESTA DE CONFIRMACIN DE MENSAJE ENVIADO: "CMGS=1"
			delay_ms(200);
			ClearScreen();
			PrintString(SEN);
			GotoXY(1,0);
				for(a=0;a<8;a++)
				{
				PutLCD(arraywave[a]);				//escribe en LCD confirmacin del mdem: "CMGS: 1"					
				}
			delay_ms(4000);	
			}		
		}
		else
		{
		writeeeprom(11,0);						//guarda un 0 en la localidad 11, que es la bandera de que puerta se detect cerrada***.		
		}
	ClearScreen();
	PrintString(WAIT);
	delay_ms(2000);							
	cleararray();							//borra buffer arraywave[]	
	activa_serial();
	CMGL();									//enva comando: AT+CMGL="ALL"
	stringwave('K');					//recibe respuesta, llena el arreglo arraywave[] hasta recibir una "K"
	delay_ms(200);
	GotoXY(1,0);
		for(a=3;a<11;a++)
		{
		PutLCD(arraywave[a]);				//escribe en LCD respuesta del mdem
		}
	delay_ms(2000);
		if(arraywave[10]=='1')				//verifica si hay un mensaje pendiente
		{
		ClearScreen();
		PrintString(RECIBIDO);					//CONFIRMA QUE EL MENSAJE YA FUE RECIBIDO
		delay_ms(2000);
			if(arraywave[17]=='U')				//SI EL MENSAJE ESTA MARCADO COMO "UNREAD"
			{
			z=0;
			}
			else
			{
			z=-2;								//SI EL MENSAJE EST MARCADO COMO "READ"
			}
			ClearScreen();
			PrintString(TEL);
			PutLCD(arraywave[26+z]);				//****
			PutLCD(arraywave[27+z]);				//****LINEAS NUEVAS MUESTRA CLAVE LADA EN LCD			
			GotoXY(1,0);
				for(a=28+z;a<36+z;a++)
				{
				PutLCD(arraywave[a]);				//escribe en LCD el telfono del usuario
				}
			delay_ms(4000);
			ClearScreen();
			PrintString(PAS);
			GotoXY(1,0);
				for(a=63+z;a<69+z;a++)
				{
				PutLCD(arraywave[a]);				//escribe en LCD el mensaje, 6 caracteres incluye password y comando
				}
			delay_ms(4000);
				if(PASS[0]==arraywave[63+z]&&PASS[1]==arraywave[64+z]&&PASS[2]==arraywave[65+z]&&PASS[3]==arraywave[66+z])
				{
				GotoXY(1,0);
				PrintString(OK);								//PASSWORD CORRECTO
				delay_ms(2000);
					for(a=28+z;a<36+z;a++)							//for(a=26;a<34;a++)
					{
					writeeeprom((a-(28+z)),arraywave[a]);		//guarda en EEPROM el telfono autorizado, en las localidades 0 a 7												
					}
				writeeeprom(8,arraywave[26+z]);
				writeeeprom(9,arraywave[27+z]);			//++++++++++++++LINEAS NUEVAS guarda clave LADA en localidades 8 y 9 de eeprom.
				writeeeprom(10,106);						//guarda un 106 en la localidad 10, que es la bandera de que ya existe un usuario autorizado***															
				GotoXY(1,0);
				PrintString(GUARDA);							//muestra en el LCD que ya guard el telfono en EEPROM
				delay_ms(2000);
				read_phoneLCD();							//muestra en LCD el telfono del usuario
					if(arraywave[67+z]=='T'&&arraywave[68+z]=='P'){r=4;}    //ENVIA LECTURA DEL SENSOR DE TEMPERATURA
					if(arraywave[67+z]=='S'&&arraywave[68+z]=='T'){r=2;} //PASSWORD CORRECTO, ENVA STATUS.
					if(arraywave[67+z]=='R'&&arraywave[68+z]=='0'){RELE=0;r=0;}    //DESACTIVA EL RELEVADOR
					if(arraywave[67+z]=='R'&&arraywave[68+z]=='1'){RELE=1;r=1;}	//ACTIVA EL RELEVADOR					

				clearbuffer();							//borra el buffer arraywave[], que es en donde se almacenan los mensajes provenientes del mvil
				ClearScreen();
				PrintString(ENVIANDO);
				delay_ms(2000);
				activa_serial();
				CMGS1(r);								//ENVA EL MENSAJE AL TELFONO AUTORIZADO. EL ARGUMENTO (r) DETERMINA QU MENSAJE SE ENVIA
				cleararray();							//LIMPIA BUFFER DE RECEPCIN DE CARACTERES DEL MDEM
				starwave();								//ESPERA LA RESPUESTA DE CONFIRMACIN DE MENSAJE ENVIADO: "CMGS=1"
				delay_ms(200);
				ClearScreen();
				PrintString(SENT);
				GotoXY(1,0);
					for(a=0;a<8;a++)
					{
					PutLCD(arraywave[a]);				//escribe en LCD confirmacin del mdem: "CMGS: 1"					
					}
				delay_ms(4000);	
				}
				else
				{
				GotoXY(1,0);							//PASSWORD INCORRECTO
				PrintString(NOK);
				delay_ms(2000);
				clearbuffer();							//borra el mensaje del buffer del mdem.
				}
		}
	delay_ms(200);
	goto mallachica;
} 
/****************************************FIN DE MAIN******************************************/

void CSQ(void)					//funcin enva
{
	char comwave[]="AT+CSQ";
	int aa;
	delay_ms(500);
	putcUSART(65);						//enva "A"
malla2:
	x=getcNOECO();
	if(x!=65)goto malla2;				//espera el eco de la "A".
	putcUSART(84);						//enva "T"
	x=getcNOECO();						//lee el eco de "T"
	LEN=6;						//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putcUSART(comwave[aa]);				//enva caracter
		x=getcNOECO();					//recibe el eco
		}
		putcUSART(13);					//manda el CR
}

void CREG(void)					//funcin enva comando para conocer si ya est enlazado en la red GSM
{
	char comwave[]="AT+CREG?";
	int aa;
	delay_ms(500);
	putcUSART(65);						//enva "A"
malla2:
	x=getcNOECO();
	if(x!=65)goto malla2;				//espera el eco de la "A".
	putcUSART(84);						//enva "T"
	x=getcNOECO();						//lee el eco de "T"
	LEN=8;								//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putcUSART(comwave[aa]);				//enva caracter
		x=getcNOECO();					//recibe el eco
		}
		putcUSART(13);					//manda el CR
}

void CMGF(void)							//funcin verifica que mdem est en modo texto.
{
	char comwave[]="AT+CMGF?";
	int aa;
	delay_ms(500);
	putcUSART(65);						//enva "A"
malla2:
	x=getcNOECO();
	if(x!=65)goto malla2;				//espera el eco de la "A".
	putcUSART(84);						//enva "T"
	x=getcNOECO();						//lee el eco de "T"
	LEN=8;								//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putcUSART(comwave[aa]);				//enva caracter
		x=getcNOECO();					//recibe el eco
		}
		putcUSART(13);					//manda el CR
}

void CMGD(void)							//COMANDO VACA EL BUFFER DEL MDEM DE MENSAJES SMS.
{
	char comwave[]="AT+CMGD=1,1";
	int aa;
	delay_ms(500);
	putcUSART(65);						//enva "A"
malla2:
	x=getcNOECO();
	if(x!=65)goto malla2;				//espera el eco de la "A".
	putcUSART(84);						//enva "T"
	x=getcNOECO();						//lee el eco de "T"
	LEN=11;						//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putcUSART(comwave[aa]);				//enva caracter
		x=getcNOECO();					//recibe el eco
		}
		putcUSART(13);					//manda el CR
}

void CMGL(void)							//comando interroga al mdem para ver si hay algn mensaje.
{
	char comwave[]={65,84,43,67,77,71,76,61,34,65,76,76,34,0};		//define string "AT+CMGL="ALL"
	int aa;
	delay_ms(500);
	putcUSART(65);						//enva "A"
malla2:
	x=getcNOECO();
//	x=timed_getc('A');
	if(x!=65)goto malla2;				//espera el eco de la "A".
	putcUSART(84);						//enva "T"
	x=getcNOECO();
//	x=timed_getc('T');						//lee el eco de "T"	
	LEN=13;						//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putcUSART(comwave[aa]);				//enva caracter
		x=getcNOECO();
//		x=timed_getc('A');;					//recibe el eco************************************************************************
		}
		putcUSART(13);					//manda el CR
}

void stringwave(int h)					//recibe cadena de respuesta del mdem hasta que encuentre el caracter dado 
										//en el argumento entre parntesis al llamar a la funcin.
{
	LENWAVE=0;
	while(1)
	{arraywave[LENWAVE]=getcNOECO();
//	{arraywave[LENWAVE]=timed_getc('K');
	if(arraywave[LENWAVE]==h)			//lee caracteres hasta detectar el argumento
		{
		goto forward;					
		}
	LENWAVE++;
	if(LENWAVE>68)goto forward;
	}
forward:
	a=a;
}


void at(void)						//MANDA COMANDO BASICO AT Y ESPERA EL OK
{
lop:
	delay_ms(500);
	ClearScreen();
	PutLCD('A');
	PutLCD('T');
	delay_ms(1000);
	putcUSART(65);				//MANDA 'A'
	x=timed_getc();				//ESPERA ECO DE LA 'A'
	putcUSART(84);				//ESCRIBE 'T'
	y=timed_getc();				//ESPERA ECO DE LA T
	putcUSART(13);				//ENVIA 'CR'
								//ESPERA RESPUESTA DE MODEM
	a=0;
	while(1)
	{arraywave[a]=timed_getc();	
	if(arraywave[a]==75)goto sigue;			//lee caracteres hasta detectar la "K"
	if(arraywave[a]==0)goto lop;
	a++;
	}
sigue:									
	GotoXY(1,0);
	PutLCD(arraywave[3]);
	PutLCD(arraywave[4]);
	delay_ms(1000);
}



void cleararray(void)					//llena del caracter espacio [20H] el arreglo "arraywave[]"
{
	for(a=0;a<70;a++)
	{
	arraywave[a]=32;
	}
}

void clearbuffer(void)						//borra los mensajes de entrada que estn en el buffer de mensajes del mdem.
{
	delay_ms(2000);
	activa_serial();
	CMGD();									//enva "AT+CMGD=1,1" para borrar el buffer de mensajes SMS
	delay_ms(200);
	ClearScreen();
	PrintString(BUFFER);
	delay_ms(2000);							//espera para dar tiempo a vaciar el buffer, si es que tiene muchos mensajes.
	activa_serial();
	CMGL();									//comando verifica que el buffer est vaco.
	stringwave('K');						//recibe respuesta, llena el arreglo hasta recibir una "K"
	delay_ms(200);
	GotoXY(1,0);
		for(a=3;a<LENWAVE+1;a++)
		{
		PutLCD(arraywave[a]);				//escribe en LCD respuesta del mdem
		}
	delay_ms(2000);
}


void lee_telefono(void)
{
char a;
	for(a=0;a<8;a++)
	{
	arraywave[a]=readeeprom(a);			//lee telfono autorizado de la eeprom lo almacena en el arreglo arraywave[]
	arraywave[8]=0;										//son 8 dgitos, no incluye clave lada. Termina string con caracter NULL
	}
}	

void read_phoneLCD(void)					//lee eeprom y escribe en LCD el telfono autorizado
{
	for(a=0;a<8;a++)
	{
	arraywave[a]=readeeprom(a);			//lee telfono autorizado de la eeprom
	arraywave[8]=0;							//terminacin de string
	}
	delay_ms(200);
	ClearScreen();
	PrintString(USER);
	PutLCD(readeeprom(8));
	PutLCD(readeeprom(9));					//muestra clave LADA leda de la EEPROM en LCD
	GotoXY(1,0);
	PrintString(arraywave);					//escribe el telfono autorizado en LCD
	delay_ms(2000);							
}
											//ENVA MENSAJES DE CONFIRMACIN AL USUARIO CON COMANDO DE FORMATO: "AT+CMGS=5521806666..."
											//EL ARGUMENTO DE LA FUNCIN DETERMINA EL MENSAJE QUE SE ENVIAR
void CMGS1(int h)							
{
	int aa;
	char comwave[]={65,84,43,67,77,71,83,61,34,20,20,20,20,20,20,20,20,20,20,34,0};		//define string <AT+CMGS="        ">
	const char comwave100[]="RELEVADOR INACTIVO ";
	const char comwave101[]="RELEVADOR ACTIVO ";
	const char comwave102[]="USER OK ";
	const char comwave103[]="PUERTA ABIERTA";
	const char comwave104[]="PUERTA CERRADA";
	lee_telefono();
		for(aa=0;aa<8;aa++)
		{
		comwave[aa+11]=arraywave[aa];			//acomoda el telefono sin cdigo lada en el arreglo
		}
	comwave[9]=readeeprom(8);
	comwave[10]=readeeprom(9);							//acomoda el cdigo lada en el arreglo 
	delay_ms(500);
	putcUSART(65);						//enva "A"
malla8:
	x=getcNOECO();
	if(x!=65)goto malla8;				//espera el eco de la "A".
	putcUSART(84);						//enva "T"
	x=getcNOECO();						//lee el eco de "T"
	LEN=20;						//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putcUSART(comwave[aa]);				//enva caracter
		x=getcNOECO();					//recibe el eco
		}
	putcUSART(13);					//manda el CR
malla9:
	x=getcNOECO();
	if(x!=62)goto malla9;				//espera el promt ">".
		if(h==0)
		{
		LEN=18;										//"RELEVADOR INACTIVO"
			for(aa=0;aa<LEN;aa++)
			{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave100[]
			putcUSART(comwave100[aa]);				//manda caracter al mdem
			x=getcNOECO();					//recibe el eco
			}
		putcUSART(26);							//manda <CTRL Z>
		}
		
		if(h==1)
		{
		LEN=16;										//"RELEVADOR ACTIVO"
			for(aa=0;aa<LEN;aa++)
			{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave101[]
			putcUSART(comwave101[aa]);				//manda caracter al mdem
			x=getcNOECO();					//recibe el eco
			}
		putcUSART(26);							//manda <CTRL Z>	
		}
//*******************************************************ENVO DEL STATUS DEL SISTEMA***********************************************
		if(h==2)							
		{
		LEN=8;									//"USER OK "
			for(aa=0;aa<LEN;aa++)
			{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave102[]
			putcUSART(comwave102[aa]);				//manda caracter al mdem
			x=getcNOECO();					//recibe el eco
			}
			if(RELE==1)
			{
			LEN=17;										//"RELEVADOR ACTIVO "
				for(aa=0;aa<LEN;aa++)
				{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave101[]
				putcUSART(comwave101[aa]);				//manda caracter al mdem
				x=getcNOECO();						//recibe el eco
				}
			}
			else
			{
			LEN=19;										//"RELEVADOR INACTIVO "
				for(aa=0;aa<LEN;aa++)
				{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave101[]
				putcUSART(comwave100[aa]);				//manda caracter al mdem
				x=getcNOECO();						//recibe el eco
				}
			}
			if(SW1==1)
			{
			LEN=14;										//"ALARMA ACTIVA"
				for(aa=0;aa<LEN;aa++)
				{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave101[]
				putcUSART(comwave103[aa]);				//manda caracter al mdem
				x=getcNOECO();						//recibe el eco
				}
			}
			else
			{
			LEN=14;										//"PUERTA CERRADA"
				for(aa=0;aa<LEN;aa++)
				{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave101[]
				putcUSART(comwave104[aa]);				//manda caracter al mdem
				x=getcNOECO();						//recibe el eco
				}
			}		
		putcUSART(26);							//manda <CTRL Z>	
		}
//**************************************************FIN DE ENVO DEL STATUS DEL SISTEMA*****************************************************
		if(h==3)
		{
		LEN=14;									//PUERTA ABIERTA
			for(aa=0;aa<LEN;aa++)
			{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave103[]
			putcUSART(comwave103[aa]);				//manda caracter al mdem
			x=getcNOECO();					//recibe el eco
			}
		putcUSART(26);							//manda <CTRL Z>	
		}
//*************************************************ENVIO DE VALOR DE SENSOR DE TEMPERATURA**************************************************
		if(h==4)
		{
		GRADOS=ds1820_read();				//GRADOS ES VARIABLE DE PUNTO FLOTANTE
		entero=GRADOS;						//PARTE ENTERA
		decimal=(GRADOS-entero)*10;			//PARTE DECIMAL
		sprintf(array,"TEMPE= %3d.%d",entero,decimal);		//CONVIERTE A STRING 
		LEN=12;									//TEMPE= 23.4 
			for(aa=0;aa<LEN;aa++)
			{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO array[]
			putcUSART(array[aa]);				//manda caracter al mdem
			x=getcNOECO();					//recibe el eco
			}
		putcUSART(26);							//manda <CTRL Z>	
		init_bolt();						//reinicializa el puerto A para la alarma de puerta.
		}
}

void starwave (void)				//espera confirmacin de la red GSM y el mdem de que el mensaje fu enviado: "+CMGS 1"
{
int a;
malla20:
	x=getcNOECO();						//***ESTA FUNCIN PODRA CAMBIARSE A "timed_getc(int a)" PARA EVITAR QUE QUEDE ATRAPADO EL PROGRAMA
										//***EN CASO DE QUE EL MDEM NO RECIBA LA CONFIRMACIN DE MENSAJE ENVIADO DE LA RED GSM.
	if(x!=43)goto malla20;				//espera el caracter "+".
	LEN=7;								//almacena longitud del string
		for(a=0;a<LEN;a++)
		{
		arraywave[a]=getcNOECO();					//recibe mensaje
		}
}									


/*FUNCION ESPERA UN CARACTER DEL PUERTO SERIAL, LO LEE Y ENVIA EL ECO*/
/*REGRESA CON EL VALOR DEL CARACTER LEIDO*/
char getcECO(void)
{

char a;	
	while(1)
	{
	mallo:			
		while (!DataRdyUSART());			//ESPERA BANDERA LISTA
		{
		a=getcUSART();						//LEE REGISTRO DE RECEPCION DEL USART
		putcUSART(a);						//ENVIA EL ECO
		}
	}
return a;								//REGRESA DE LA FUNCION CON CARACTER LEIDO
}

/*FUNCION ESPERA UN CARACTER DEL PUERTO SERIAL, LO LEE Y*/
/*REGRESA CON EL VALOR DEL CARACTER LEIDO*/
char getcNOECO(void)
{
char a;
		
		while(!DataRdyUSART());			//ESPERA BANDERA LISTA
		{
		a=getcUSART();						//LEE UN CARACTER DEL USART,NO HAY ECO
		}
return a;								
}

void pin(void)
{
	putcUSART(65);
	getcNOECO();
	putcUSART(84);
	getcNOECO();
	putcUSART(13);
	getcNOECO();
//	z=getcUSART();
//	z=getcUSART();
//	z=getcUSART();
}

char timed_getc(void) 					//equivalente a getchar(), pero con timeout de 100 milisegundos.
{										//si se vence el timeout, la subrutina regresa con VALOR 0
long int timeout;
	for(timeout=0;timeout<200000;timeout++)
	{
		if(DataRdyUSART()==1)
		{
		return(getcUSART());
		}
		else continue;
	}							//hay caracter en buffer?  
	
	return(0);	
}	

void activa_serial(void)					//INICIALIZA PUERTO SERIAL
{
OpenUSART(USART_TX_INT_OFF & USART_RX_INT_ON &
USART_ASYNCH_MODE & USART_EIGHT_BIT &
USART_CONT_RX & USART_BRGH_LOW, 77);				//SPBRG = 77 PARA 9600 BPS
}