/*Bolt 18F2550 system	
Proximity sensor application program. 3 modes of operation.
square wave PWM program generates approx. 36 kHz with 50% duty cycle.
RB3 output generates approx. PWM 883 and 883 us space.
The output of TMF5360 enters RA2, 18F2550 pin 4.
Mode 1 PROXIMITY DETECTOR MODE (SW1.. SW2 off): relay is active when an object
approaches a distance of 30 cm or less of the infrared LED. Remains active
until the object moves away.
Mode 2 TOGGLE SWITCH (SW1 = ON, remaining OFF): Turns the relay if the object is approaching. 
Disable if the object is near again and so on.
Mode 3 Timer Mode (SW1 = ON, SW2 = ON, remaining OFF): activates the relay for 6 seconds when the
object is approaching.
The value of resistor R1 (1.5K) in proximity sensor module may be changed to adjust for a larger or 
shorter distance.
*/

#include <p18cxxx.h>
#include <delays.h>
#include <timers.h>
#include <pwm.h>
#include "18F2550BOLT.h"

extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 
void OCHOMS(void);
#pragma code
long int i,j,k;
void main(void)
{
init_bolt();
OpenTimer2( T2_PS_1_4 );  		//inicialize timer 2
OpenPWM2(83);  				//frecuency del PWM
SetDCPWM2(160);  			//duty cycle del PWM
TRISA=0X36;
k=microsw();
		while(1)
		{
		j=0;
			for(i=0;i<30;i++)
			{			
			TRISB=0X00;		//generate PWM
			delay_us(200);				
			delay_us(200);
			delay_us(200);
				if(RA2==0)j++;
			delay_us(200);				
			delay_us(200);				
			TRISB=0X08;		//inhibits PWM
			delay_us(400);				
			delay_us(200);
			delay_us(200);
				if(RA2==1)j++;
			delay_us(200);				
			delay_us(200);	
			}
			switch(k)
			{
			case 15:
				if (j>58)			//parameter to adjust threshold
				{
					if(RELE==0)
					{
					RELE=1;
					delay_ms(1000);
					}	
				}
				else
				{
					if(RELE==1)
					{
					RELE=0;
					delay_ms(1000);	
					}				
				}
			break;
			case 14:
				if (j>58)
				{
					if(RELE==0)
					{
					RELE=1;
					delay_ms(1000);
					}
					else
					{
					RELE=0;
					delay_ms(1000);	
					}				
				}
			break;
			case 12:
				if (j>58)		//parameter to adjust threshold
				{
					if(RELE==0)
					{
					RELE=1;
					delay_ms(6000);
					RELE=0;
					}		
				}
			break;		
			}
		delay_ms(100);
		}	
//ClosePWM2();  
}


					
												
					