//TIMER 0 INTERRUPT HANDLING
//COMPILER C18 V3.40, MPLAB V8.63, BOLT 18F2550
//FLASHES LED RB0 EACH SECOND
//PROGRAM MAKES A TIME BASE FOR DEVELOPING
//A REAL TIME CLOCK 
//FREQUENCY OF 18F2550 IS 48 MHZ


#include <p18cxxx.h>
#include <delays.h>
#include <timers.h>
#include "18F2550BOLT.h"
#define CLOCK_TIMER0 12000000;	//frequency (hertz) OF TIMER0

void timer_isr(void);

extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code _HIGH_INTERRUPT_VECTOR = 0x000808
void _high_ISR (void)
{
	_asm goto timer_isr _endasm
}

#pragma code
int long Ticker; 
int Segundos=0; 
int segundo_previo=0;

#pragma interrupt timer_isr

void timer_isr(void)
{
Ticker=Ticker-65536;                    // Decrement ticker  
  if (Ticker<65536)                      // if a second is done 
  {
	Ticker=Ticker+CLOCK_TIMER0;      	//   Increment ticker 
    Segundos++;                           //   Incrementa number of seconds 
  } 
	INTCONbits.TMR0IF = 0 ;				//enable interrupt
}

void main() 
{
	init_bolt();
	PORTB=0;
	Ticker=CLOCK_TIMER0;
	OpenTimer0 (TIMER_INT_ON & T0_SOURCE_INT & T0_16BIT);			//T0_PS_1_256
	INTCONbits.GIE = 1; 					//enable global interrupts
	while(1) 
  	{
		if(Segundos!=segundo_previo) 
    	{segundo_previo=Segundos; 
      		if(RB0)RB0=0;
	  		else RB0=1; 
    	}  
  	} 
} 

